import 'dart:io';

import 'package:linio/linio.dart';
import 'package:mocktail/mocktail.dart';
import 'package:test/test.dart';

import '../mock/mocks.dart';

class MockFile extends Mock implements File {}

//TODO WARN - DO NOT EDIT THIS FILE - LINE NUMBERS ARE HARDCODED
void main() {
  group('log point test', () {
    test('log point simple', () {
      final console = TestConsole();
      final linio = Linio.custom(printers: [
        console
      ], manipulators: [
        LogPointCommand(),
      ]);
      LinioInlineBuilder builder = LinioInlineBuilder.b(name: 'main');
      linio.log('log_point');
      builder.log('log_point');
      expect(console.logs, [
        '(file:///Users/rafaldziuryk/AndroidStudioProjects/linio/packages/linio/test/log_point/simple_test.dart:22:13)',
        '(file:///Users/rafaldziuryk/AndroidStudioProjects/linio/packages/linio/test/log_point/simple_test.dart:23:15)',
      ]);
    });

    test('log point with tag', () {
      final console = TestConsole();
      Linio.custom(printers: [
        console
      ], manipulators: [
        LogPointCommand(),
      ]);
      LinioInlineBuilder builder = LinioInlineBuilder.b(name: 'main');
      builder.logPoint();
      expect(console.logs, [
        '(file:///Users/rafaldziuryk/AndroidStudioProjects/linio/packages/linio/test/log_point/simple_test.dart:38:15)',
      ]);
    });
  });
}
